﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Kendo.Mvc.UI;
using KendoMVCWrappers.Models;
using Kendo.Mvc.Extensions;
using System.Collections;
using System.IO;
using System.Text;

namespace KendoMVCWrappers.Controllers
{
    public class HomeController : Controller
    {
        private NwEntities db = new NwEntities();

        public ActionResult Index()
        {
            ViewBag.Message = "Modify this template to kick-start your ASP.NET MVC application.";

            return View();
        }

        public ActionResult Read([DataSourceRequest] DataSourceRequest request)
        {
            return Json( db.Products.ToDataSourceResult(request));
        }

        public FileResult Export([DataSourceRequest]DataSourceRequest request)
        {

            IEnumerable products = db.Products.ToDataSourceResult(request).Data;
            MemoryStream output = new MemoryStream();
            StreamWriter writer = new StreamWriter(output, Encoding.UTF8);
            writer.Write("ProductName,");
            writer.Write("UnitPrice,");
            writer.Write("QuantityPerUnit");
            writer.WriteLine();
            foreach (Product product in products)
            {
                writer.Write(product.ProductName);
                writer.Write(",");
                writer.Write("\"");
                writer.Write(product.UnitPrice);
                writer.Write("\"");
                writer.Write(",");
                writer.Write("\"");
                writer.Write(product.QuantityPerUnit);
                writer.WriteLine();
            }
            writer.Flush();
            output.Position = 0;

            return File(output, "text/comma-separated-values", "Products.csv");
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your quintessential app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your quintessential contact page.";

            return View();
        }
    }
}
